/*  C  */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <omp.h>

#define N 100000000


int main () {

   int* a;
   a = (int *) malloc(N*sizeof(int));
   if (a == NULL) {
      printf("Bad malloc of a, exiting\n");
      exit(-1);
   }

   for (int i = 0; i < N; i++) {
      a[i] = 1;
   }

// PART a
   double t = // ADD A CALL TO GET THE TIME FOR THE THREAD
   int s = 0;
   for (int i = 0; i < N; i++) {
      s = s + a[i];
   }
   t = /* ADD A CALL TO GET THE TIME FOR THE THREAD */ - t;
   printf("sequential reduction time is %f, value is %d\n", t, s);
   printf("\n\n\n\n");

// PART b
   int nt;
   #pragma // COMPLETE THE PRAGMA FOR A PARALLEL REGION
   {
      #pragma omp CREATE THE CALL FOR A SINGLE REGION
      {
         nt = // ADD A CALL TO GET THE NUMBER OF THREADS
      }
   }

   int results[nt];
   for (int i = 0; i < nt; i++) {
      results[i] = 0;
   }

   t = /* ADD A CALL TO GET THE OPEN MP TIME */;
   #pragma // FINISH THE PRAGMA FOR A PARALLEL FOR
   for (int i = 0; i < N; i++) {
      results[/* ADD A CALL AS THE INDEX TO GET THE THREAD NUMBER FOR THIS TRHEAD */] += a[i];
   }

   s = 0;
   for (int i = 0; i < nt; i++) {
      s += results[i];
   }
   t = /* ADD A CALL TO GET THE OPEN MP TIME */ - t;
   printf("hand-rolled parallel reduction time is %f, value is %d\n", t, s);
   printf("\n\n\n\n");

// PART c
   s = 0;
   t = omp_get_wtime( );
   #pragma // COMPLETE THIS PRAGMA TO MAKE THE FOLLOWING FOR AN OPENMP PARALLEL FOR PEFFORMING A REDUCTION ON s
   for (int i = 0; i < N; i++) { 
      s += a[i];
   }
   t = /* ADD A CALL TO GET THE OPEN MP TIME */ - t;
   printf("OMP reduction time is %f, value is %d\n", t, s);
   printf("\n\n\n\n");
}
      
   
